version = "$VERSION 1.01 {01/25/2018 06:20:12 PM} VERSION$"

/*
Image object that allows you to move it around the screen 
by left chicking the mouse and moving it. 

*/


class MoveImage(parentObj, name) of IMAGE(parentObj, name) custom
   with (this)
		onOpen = class::ONOPEN
      onLeftMouseDown = class::IMAGE1_ONLEFTMOUSEDOWN
      onLeftMouseUp = class::IMAGE1_ONLEFTMOUSEUP
      onMouseMove = class::IMAGE1_ONMOUSEMOVE
      height = 225.0
      left = 0.0
      top = 0.0
      width = 288.0
      metric = 6	// Pixels
   endwith
	
	function onOpen
		this.lMove = false
		return

   function IMAGE1_onLeftMouseDown(flags, col, row)
      this.lMove = true
		this.mousePointer = 13	// Hand
		class::whereIsMouse()
		this.orgX = this.X
		this.orgY = this.Y
		this.imageX = this.left
		this.imageY = this.top
		return
		
   function IMAGE1_onLeftMouseUp(flags, col, row)
      this.lMove = false
		this.mousePointer = 0	// Default
      return
		
   function IMAGE1_onMouseMove(flags, col, row)
      if this.lMove
			class::whereIsMouse()
			? this.X
			? this.Y
			// move image
			this.left = this.imageX - (this.orgX - this.X)
			this.top = this.imageY - (this.orgY - this.Y)
			this.mousePointer = 13	// Hand
		endif
      return
		
	function whereIsMouse
      local crect
      // find the position of the mouse
		if type('GetCursorPos') # 'FP'
			extern clogical GetCursorPos(cptr) user32
		endif
		if type('ScreenToClient') # 'FP'
			extern clogical ScreenToClient(chandle, cptr) user32
		endif
      cRect = new string(space(4))
      GetCursorPos(cRect)
      ScreenToClient(this.form.hwndClient,cRect)
      this.X = int(class::getLong(0,cRect))
      this.Y = int(class::getLong(4,cRect))
      //? "X:"+this.X+"  Y:"+this.Y
		release object cRect
		return		
		
   function getLong(nIndex,cStr)
      local n
      n = cStr.getByte(nIndex) + ;
         bitlshift(cStr.getByte(nIndex + 1),  8) + ;
         bitlshift(cStr.getByte(nIndex + 2), 16) + ;
         bitlshift(cStr.getByte(nIndex + 3), 24)
      if bitset(n, 31)
         n := - bitnot(n)
      endif
      return n
		
endclass
